﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private FlacEncoder As JavaObject
	Private StreamConfig As JavaObject
	Private FlacOutStream As JavaObject
	Private RAF As RandomAccessFile
	Private BlockSize As Int
	Type WavHeaderType (Channels As Int,SampleRate As Int,BitsPerSample As Int,BytesPerSample As Int)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(SourceDir As String,SourceFile As String,TargetDir As String,TargetFile As String)

	If SourceDir = File.DirAssets Then
		File.Copy(SourceDir,SourceFile,File.DirInternal,SourceFile)
		SourceDir = File.DirInternal
	End If
	'Open the source File
	RAF.Initialize2(SourceDir,SourceFile,True,True)

	Dim WavHeader As WavHeaderType = ReadWavHeader(RAF)
	Log("WH Channels " & WavHeader.Channels)
	Log("WH SampleRate " & WavHeader.SampleRate)
	Log("WH BitsPerSample " & WavHeader.BitsPerSample)

	'Prepare the encoder
	FlacEncoder.InitializeNewInstance("javaFlacEncoder.FLACEncoder",Null)
	StreamConfig.InitializeNewInstance("javaFlacEncoder.StreamConfiguration",Null)
	FlacOutStream.InitializeNewInstance("javaFlacEncoder.FLACFileOutputStream",Array(File.Combine(TargetDir,TargetFile)))
	FlacEncoder.RunMethod("setStreamConfiguration",Array(StreamConfig))
	FlacEncoder.RunMethod("setOutputStream",Array(FlacOutStream))
	FlacEncoder.RunMethod("openFLACStream",Null)
	
	BlockSize = StreamConfig.RunMethod("getMaxBlockSize",Null)

	'Process the Audio
	'Skip the wav header
	Dim Pos As Int = 44
	Dim Buffer(BlockSize * WavHeader.Channels) As Int
	Dim Last As Boolean = False
	Dim BlockPos As Int = 0
	Do While Pos < RAF.Size -1
		Do While Pos < RAF.Size -1 And BlockPos < Buffer.Length
			Buffer(BlockPos) = RAF.ReadShort(Pos)
			Pos = Pos + 2
			BlockPos = BlockPos + 1
		Loop
		Log("Pos " & Pos & " of " & (RAF.Size-1))
		If RAF.Size -1 = Pos Then Last = True
		FlacEncoder.RunMethod("addSamples",Array(Buffer,BlockSize))
		FlacEncoder.RunMethod("encodeSamples",Array(BlockSize,Last))
		Dim Buffer(BlockSize * WavHeader.Channels) As Int
		BlockPos = 0
	Loop


End Sub
Sub ReadWavHeader(RF As RandomAccessFile) As WavHeaderType
	Dim WH As WavHeaderType
	WH.Initialize
	WH.Channels = RF.ReadShort(22)
	WH.SampleRate = RF.ReadInt(24)
	WH.BitsPerSample = RF.ReadShort(34)
	WH.BytesPerSample = WH.BitsPerSample / 8
	Return WH
End Sub